import os
import sys
from Helper import Helper
import datetime

CWD = os.path.dirname(os.path.abspath(__file__))
YLOG = os.path.sep.join(CWD.split(os.path.sep)[:-2])
sys.path.extend([CWD, YLOG])


__CSL = None
def symlink(source, link_name):
    '''symlink(source, link_name)
       Creates a symbolic link pointing to source named link_name'''
    global __CSL
    if __CSL is None:
        import ctypes
        csl = ctypes.windll.LoadLibrary("kernel32.dll").CreateSymbolicLinkW
        csl.argtypes = (ctypes.c_wchar_p, ctypes.c_wchar_p, ctypes.c_uint32)
        csl.restype = ctypes.c_ubyte
        __CSL = csl
    flags = 0
    if source is not None and os.path.isdir(source):
        flags = 1
    if __CSL(link_name, source, flags) == 0:
        raise ctypes.WinError()
    
    
class ReportHelper(Helper):
    
    path_base = None
    path_link = None
    path = None

    def __init__(self):
        self.path_base = os.path.join(YLOG, 'report')
        if not os.path.exists(self.path_base):
            os.makedirs(self.path_base)
        self.path_link = os.path.join(self.path_base, 'analytic')
        self.path = os.path.join(self.path_base, 'analytic %s' % datetime.datetime.strftime(datetime.datetime.now(), '%Y-%m-%d_%H-%M-%S'))
        os.makedirs(self.path)
        if os.path.exists(self.path_link):
            os.removedirs(self.path_link)
        symlink(self.path, self.path_link)

