from suds.client import Client
import suds
import datetime
import logging
import urllib2

class SoapRequestor(object):
	"""
	Helper class to contruct and send SOAP requests
	"""

	client = None 				#: client object for making calls and receiving responses
	apiWSDL = ""				#: WSDL file url / location to define calls 
	logger = None 				#: logger to send loggin information to.  Logger comes from pytest test definitions
	
	
	def __init__(self,logger,WSDL,doctor=None):
		"""
		Constructor for class 

		Args :
		logger : (logger) instance of a logging object configured in testing project 
		WSDL : (str) URL to the location of the wsdl file
		doctor : (ImportDoctor) instance of the suds.xsd.doctor.ImportDoctor class for fixing broken schemas
				
		"""
		
		self.logger = logger
		self.apiWSDL = WSDL
		

		try :

			self.client = Client(self.apiWSDL,doctor=doctor)
		except urllib2.URLError,e:
			print str(e)

	
	def getMethods(self):
		"""
		Fetches a list of method objects from the wsdl and returns them in a list

		Returns: (list) of suds Method objects containing all information on calling method and handling the response.

		"""
		methods = self.client.wsdl.services[0].ports[0].methods.values()


		return methods



# # #create logger
# logger = logging.getLogger('test')
# logger.setLevel(logging.DEBUG)

# # create console handler and set level to debug
# ch = logging.StreamHandler()
# ch.setLevel(logging.DEBUG)

# # create formatter
# formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

# # add formatter to ch
# ch.setFormatter(formatter)

# #add ch to logger
# logger.addHandler(ch)
# logging.basicConfig(level=logging.INFO)
# logging.getLogger('suds.client').setLevel(logging.DEBUG)
# logging.getLogger('suds.transport').setLevel(logging.DEBUG)
# logging.getLogger('suds.xsd.schema').setLevel(logging.DEBUG)
# logging.getLogger('suds.wsdl').setLevel(logging.DEBUG)

#wsdl = "http://mtljiraqcprod01.ad.ypg.com/SpiraTeam/Services/v4_0/ImportExport.svc?wsdl"
# wsdl = "http://localhost/GetAccountsWithMerchants.WSDL"
# mySoap = SoapRequestor(logger,wsdl)


# #resp = mySoap.client.set_options(service='YPG_spcGet_spcAccounts_spcWith_spcMerchants',port='GetAccounts')
# #print mySoap.client

# methods = mySoap.getMethods()
# print methods

# for method in mySoap.client.wsdl.services[0].ports[0].methods.values():
#     print '%s(%s)' % (method.name, ', '.join('%s: %s' % (part.type, part.name) for part in method.soap.input.body.parts))


#print  methods[0]
#services = mySoap.client.service
#myAccount = mySoap.client.factory.create(u'xsdLocal0:Account')
#myAccount.AccountNum="3333333"
#print myAccount


#print mySoap.client.wsdl.services[0].ports[0].methods.values()[0].soap.input.body.parts
#print services.GetAccounts("Y","","","","4164662766","")
# try :

# 	resp = mySoap.client.service.GetAccounts("Y","","","","4164662766","")

# except suds.WebFault, e:
# 	print str(e)

# print mySoap.client.last_sent()
#print resp


